<?php
//
//   CF Image Hosting Pro
//   -------------------------------
//
//   Author:    codefuture.co.uk
//   Version:   beta 0.26
//   Date:      29/05/2011
//
//   download the latest version from - http://codefuture.co.uk/projects/imagehost/
//
//   Copyright (c) 2011 codefuture.co.uk
//   This file is part of the CF Image Hosting Script.
//
//   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
//   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
//   COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
//   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF
//   OR  IN  CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//
//
//  You may not modify and/or remove any copyright notices or labels on the software on each
//  page (unless full license is purchase) and in the header of each script source file.
//
//  You should have received a full copy of the LICENSE AGREEMENT along with
//  CF Image Hosting Script.  If not, see http://codefuture.co.uk/projects/imagehost/license/
//   
////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////
// default settings

// Font
	$font['font']		= "../lib/font/arial.ttf";
	$font['sizexlabel']	= 8; // xlabel
	$font['sizeylabel']	= 7; // ylabel
	$font['sizeyaxis']	= 9; // yAxisInfo
	$font['angle']		= -45; // angle of X-Label

// default increments to display
	$incrementDef = array(20=>1, 200=>10, 2000=>100, 20000=>1000);

// the number of increments above the highest value to display
// (e.g. if increment is 5 and highest value is 36, the highest increment will be 40).
// This allows some padding between the top of the highest block and the top of the chart.
	$numUnitsAboveMax = 0.5;

//sizing and spacing
	$chartHeight		= 400;
	$paddingAboveLabels = 10;
	$yAxisIndent		= 40;
	$topBuffer			= 10;
	$yAxisMarkersWidth	= 8;
	$labelTextIndent	= 10;
	$chartBlockWidth	= 30;
	$spaceBetweenBlocks	= 5;
	
function checkGet($name,$default){
	if (isset($_GET[$name]) && is_numeric($_GET[$name]))
		return $_GET[$name];
	return $default;
}

////////////////////////////////////////////////////////////////////////////////////
// Data Checks
////////////////////////////////////////////////////////////////////////////////////

// check for data
	if (!isset($_GET['data'])) die("Error 1 - no data passed!");
// check there is more then one item of data
	else{
		$data = explode('|', $_GET['data']);
		if ($data <= 1)
			die("Error 2 - insufficient data passed!");
	}

////////////////////////////////////////////////////////////////////////////////////
// Font checks
////////////////////////////////////////////////////////////////////////////////////

//check font path is valid
	if (!file_exists($font['font'])) die("Error3 - font file not found");
// chech for font angle update
	$font['angle'] = checkGet('fontAngle',$font['angle']);

////////////////////////////////////////////////////////////////////////////////////
// PREP
////////////////////////////////////////////////////////////////////////////////////

// find out which X axis label will take up most space (used for clipping on eventual image).
// While we're here, also find out highest Y axis label
	$labelDims = array('width' => array(), 'height' => array());
	$labels = array();
	$highestYAxisVal = 0;
	foreach($data as $key => $val) {
		$splitter = explode(':', $val);
		$thisLabelBox = imagettfbbox($font['sizexlabel'], $font['angle'], $font['font'] , $splitter[1]);
		$labelDims['heights'][] = abs($thisLabelBox[1] - $thisLabelBox[3]);
		$labelDims['widths'][] = abs($thisLabelBox[4] - $thisLabelBox[0]);
		if ($splitter[0] > $highestYAxisVal) $highestYAxisVal = $splitter[0];
	}

// Y axis prep - what increments to display? Also, handle possible request to show more increments
// than highest data value necessitates, for visual claritys
	if (!$increment = checkGet('increment',false)) {
		foreach($incrementDef as $k => $v){
			if ($highestYAxisVal < $k){
				$increment = $v;
				break;
			}
		}
	}

// the number of increments above the highest value to display
// (e.g. if increment is 5 and highest value is 36, the highest increment will be 40).
// This allows some padding between the top of the highest block and the top of the chart.
	$highestYAxisVal += $increment*checkGet('numUnitsAboveMax',$numUnitsAboveMax);

//sizing and spacing
	$chartHeight = checkGet('chartHeight',$chartHeight);
	$bottomLabelsAreaHeight = max($labelDims['heights']) + $paddingAboveLabels;

	if (isset($_GET['yAxisInfo'])) {
		$infoBBox = imagettfbbox($font['sizeyaxis'], 90, $font['font'] , $_GET['yAxisInfo']);
		$yAxisIndent += ($infoBBox[2] - $infoBBox[6]) + 10;
	}


	foreach($labelDims['widths'] as &$t) $t += $labelTextIndent;
	$chartBlockWidth	= checkGet('blockWidth',$chartBlockWidth);
	$spaceBetweenBlocks	= checkGet('spaceBetweenBlocks',$spaceBetweenBlocks);

//some shortcut vars
	$xAxisYPos = $chartHeight - $bottomLabelsAreaHeight;
	$xPosOfRightOfLastBlock = $yAxisIndent + ($chartBlockWidth * count($data)) + (count($data)-1) + ($spaceBetweenBlocks * (count($data)+1)) + ($spaceBetweenBlocks > 0 ? 2 : 0);

//GD
	$workingImg = imagecreatetruecolor($xPosOfRightOfLastBlock, $chartHeight - $topBuffer);

////////////////////////////////////////////////////////////////////////////////////
// COLOURS CONFIG
////////////////////////////////////////////////////////////////////////////////////

	$colours = array( //specify script-wide colours in array
		"bg" => imagecolorallocate($workingImg, 255, 255, 255),
		"axis" => imagecolorallocate($workingImg, 210, 210, 210),
		"gridBg" => imagecolorallocate($workingImg, 245, 245, 245),
		"main" => imagecolorallocate($workingImg, 125, 142, 151),
		"text" => imagecolorallocate($workingImg, 98, 159, 168),
		"text2" => imagecolorallocate($workingImg, 0, 0, 0),
		"shadow" => imagecolorallocate($workingImg, 240, 240, 240)
	);

//bg color
	imagefilledrectangle($workingImg, 0, 0, imagesx($workingImg), imagesy($workingImg), $colours['bg']);

////////////////////////////////////////////////////////////////////////////////////
// Build Framework
////////////////////////////////////////////////////////////////////////////////////

//axies, grid background & grid border, Y axis info
	imageline($workingImg, $yAxisIndent, 0, $yAxisIndent, imagesy($workingImg) - $bottomLabelsAreaHeight + ($yAxisMarkersWidth * 1.5), $colours['axis']);
	imageline($workingImg, $yAxisIndent - ($yAxisMarkersWidth * 1.5), $xAxisYPos - $topBuffer, imagesx($workingImg), $xAxisYPos - $topBuffer, $colours['axis']);

// background color
	if (array_key_exists('doGridBack', $_GET)){
		imagefilledrectangle($workingImg, $yAxisIndent+1, $xAxisYPos - 1, $xPosOfRightOfLastBlock, 0, $colours['gridBg']);
	}

// not working
	if (array_key_exists('doGridBorder', $_GET)) {
		imageline($workingImg, $xPosOfRightOfLastBlock, 0, $xPosOfRightOfLastBlock, $xAxisYPos, $colours['main'][3]);
		imageline($workingImg, $yAxisIndent, 0, imagesx($workingImg), 0, $colours['main'][3]);
	}

	if (array_key_exists('yAxisInfo', $_GET)){
		imagettftext($workingImg, $font['sizeyaxis'], 90, 15, ($xAxisYPos / 2) + (($infoBBox[7] - $infoBBox[3]) / 2), $colours['text2'], $font['font'] , $_GET['yAxisInfo']);
	}

//Y axis markers
	$availArea = imagesy($workingImg) - $bottomLabelsAreaHeight;
	$onePixelEquals = $availArea / $highestYAxisVal;
	$totalStages = round($highestYAxisVal / $increment);
	$counter = 0;

	while ($counter < $totalStages+1) {
		$thisTBox = imagettfbbox($font['sizeylabel'], 0, $font['font'] , $increment * $counter);
		$textMiddleCorrector = $thisTBox[3] - $thisTBox[7] / 2;
		$thisY = $availArea - (($increment * $counter) * $onePixelEquals);
		$yLabels[] = array('x' => $yAxisIndent - 7 - $yAxisMarkersWidth - ($thisTBox[2] - $thisTBox[6]), 'y' => $thisY + $textMiddleCorrector + $topBuffer, 'text' => $increment * $counter);
		if ($counter != 0) {
			$x2 = !array_key_exists('noGrid', $_GET) ? $xPosOfRightOfLastBlock : $yAxisIndent;
			imageline($workingImg, $yAxisIndent-$yAxisMarkersWidth, $thisY, $x2, $thisY, $colours['axis']);
		}
		$counter++;
	}


////////////////////////////////////////////////////////////////////////////////////
// Build Chart
////////////////////////////////////////////////////////////////////////////////////

	$xAxisY = imagesy($workingImg) - $bottomLabelsAreaHeight;
	foreach($data as $key => $val) {
		$splitter = explode(':', $val);
		$nextX = $yAxisIndent + 1 + $spaceBetweenBlocks + ($key * ($chartBlockWidth+$spaceBetweenBlocks)) + $key;
	// label (store here, don't write, as they're going on the eventual image,
	// not the working one, for clipping purposes)
		$labels[] = array('text' => $splitter[1], 'x' => $nextX + $labelTextIndent, 'y' => $xAxisY + $paddingAboveLabels + $topBuffer);
	// block
		imagefilledrectangle($workingImg, $nextX, $xAxisY - 1, $nextX + $chartBlockWidth, ($endY = $xAxisY - ($splitter[0] / $highestYAxisVal) * 100 * ($xAxisY / 100)), $colours['main']);
		/*
	//	$_GET['gradient'] = 'dark';
	// gradient?
		$validGrads = array('light' => 255, 'dark' => 50);
		if (array_key_exists('gradient', $_GET)) {
			if (@array_key_exists($_GET['gradient'], $validGrads)) {
				for($i = $xAxisY-1; $i>$endY-1; $i--) {
					$color = imagecolorallocatealpha(
						$workingImg,
						$validGrads[$_GET['gradient']],
						$validGrads[$_GET['gradient']],
						$validGrads[$_GET['gradient']],
						(($xAxisY - 1) - $i) / ($xAxisY - 1 - $endY) * 127
					);
					imageline($workingImg, $nextX, $i, $nextX + $chartBlockWidth, $i, $color);
				}
			}
		}
		*/
	}

////////////////////////////////////////////////////////////////////////////////////
// Prep eventual image and add labels
////////////////////////////////////////////////////////////////////////////////////

	$lastLabelEndX = $nextX + $labelDims['widths'][count($labelDims['widths'])-1];
	$eventualImg = imagecreatetruecolor(imagesx($workingImg) < $lastLabelEndX ? $lastLabelEndX : imagesx($workingImg), imagesy($workingImg) + $topBuffer);
	imagefilledrectangle($eventualImg, 0, 0, imagesx($eventualImg), imagesy($eventualImg), $colours['bg']);
	imagecopy($eventualImg, $workingImg, 0, $topBuffer, 0, 0, imagesx($workingImg), imagesy($workingImg));

	foreach($labels as $val) imagettftext($eventualImg, $font['sizexlabel'], $font['angle'], $val['x'], $val['y'], $colours['text'], $font['font'] , $val['text']);
	foreach($yLabels as $val) imagettftext($eventualImg, $font['sizeylabel'], 0, $val['x'], $val['y'], $colours['text'], $font['font'] , $val['text']);

////////////////////////////////////////////////////////////////////////////////////
// Image Output
////////////////////////////////////////////////////////////////////////////////////

	header("content-type: image/png");
	imagepng($eventualImg);
	imagedestroy($workingImg);
	imagedestroy($eventualImg);

?>